{**********************************************************************
{*
{*
{* BusyBox Globals -- Version 3.0  (interface)
{*
{* Copyright (c)
{* Apple Computer, Inc.  1986-1989
{* All Rights Reserved.
{*
{* Developer Technical Support Apple II Sample Code
{*
{* This file contains the global variables used by the BusyBox 
{* program.
{*
{**********************************************************************}

UNIT uGlobals;

INTERFACE

USES    

        types,
        locator,
        memory,
        quickdraw,
        intMath,
        events,
        controls,
        windows,
        lineedit,
        dialogs,
        STDFile;

const

        AppleMenuID       = $1100;
            AboutItem     = $1101;
        FileMenuID        = $1200;
            CloseItem     = 255;   {For DA's}
            QuitItem      = $1202;
        EditMenuID        = $1300;
            UndoItem      = 250;    {For DA's}
            CutItem       = 251;    {For DA's}
            CopyItem      = 252;    {For DA's}
            PasteItem     = 253;    {For DA's}
            ClearItem     = 254;    {For DA's}

        NumWindows       = 14;
        NumWindowsMin1 = 13;

        ButButtonsID = 1;
        ButStatTextID = 2;
        ButLineEditID = 3;
        ButPicturesID = 4;
        ButPopUpsID = 5;
        ButTextEditID = 6;
        ButListsID = 7;
        
        Prog1ID = 8;
        Prog2ID = 9;
        Prog3ID = 10;
        Prog4ID = 11;
        Prog5ID = 12;
        Prog6ID = 13;


var
       MyMemoryID    : integer;      {Application ID assigned by Memory Mgr}
       Done          : boolean;      {True when quitting}
       StaggerCount  : integer;      {used to stagger windows as they open }
       Event         : WmTaskRec;    {All events are returned here}
       
       WindowList   : array [0..NumWindowsMin1] of WindowPtr;

       


procedure InitGlobals;                                     {Setup variables}

IMPLEMENTATION

procedure InitGlobals;
    begin   {of InitGlobals}
        StaggerCount := 0;
    end;    {of InitGlobals}


END.
