/*****************************************************************************
*
* IR 2.0 Resources
* The resource descriptions for IR, version 2.0
*
* These resources were created with the assistance of a popular development
* utility for the Apple IIgs and then tweaked and amplified by hand to
* cover new 6.0-specific features.
*
* by Matt Deatherage
*
* Copyright  1992 Apple Computer, Inc.  All rights reserved
*
* Release history
*
* 2.0b1		02/18/92	Matt Deatherage
* First release -- all previous incarnations of this were inline assembly
*
* 2.0b2		02/20/92	Matt Deatherage
* Fixed ID problems.  Eliminated "IR.equ.r" file, including the #defines
* in this file instead.
*
* 2.0b3		02/21/92	Matt Deatherage
* Eliminated dead resources.  Added the blast text attribute to any static
* text controls that need no LETextBox2 features (styles or justification).
* Added lowercase key equivalents like I had before the Popular Development
* Utility helpfully upshifted them all.  Made the rTwoRects resource locked
* so it won't move and I don't have to lock it.  Changed a couple of resources
* to be noCrossBank so pointer arithmetic is simplified.
*
* 2.0f1     02/24/92	Matt Deatherage
* Removed the unused "irBusy" alert because, come to think of it, it doesn't
* make a whole lot of sense to display an alert that says "IR is busy" when
* no one can do anything about it.  Changed the "About" alert to be locked
* so we can use the new AlertWindow flag to not dispose of it.  This lets
* the custom rectangle we pass stick around after AlertWindow releases the
* resource.  Marked the window parameter resource as "locked" so we don't
* have to lock it in code.
*
* 2.0 (!)	02/25/92	Matt Deatherage
* Changed version to 2.0.
*
*****************************************************************************/

#include "TypesIIgs.r"

#define If_duplicate_LEText_CNT 57 /* move this line to the top of this file */
#define Preferences_LEText_CNT 40 /* move this line to the top of this file */
#define Permanently_LEText_CNT 37 /* move this line to the top of this file */
#define LETXTBOX_00000005_CNT 33 /* move this line to the top of this file */
#define About_LEText_CNT 284 /* move this line to the top of this file */

// --- type $8001 defines

#define IR_Init_Icon $00000001

// --- type $8003 defines

#define Preferences_Ctl_List $00001003

// --- type $8004 defines

#define Prefs_Title $00000001
#define Install_NDAs_now $00000002
#define Install_FEs_permanently $00000003
#define Permanently_stat_text $00000004
#define If_duplicate_stat_text $00000005
#define Install_new_Radio $00000006
#define Try_to_kill_old_Radio $00000007
#define Always_remove_old_Radio $00000008
#define Version_control $0000000A
#define Accept $0000000B
#define Cancel $0000000C
#define Save $0000000D
#define Open_NDAs_now $0000000E
#define Do_OpenFailed $0000000F
#define Do_Alerts_on_Problems $00000010
#define Underline $00000011
#define Big_Rectangle $00000012

// --- type $8006 defines

#define PSTR_00000001 $00000001
#define PSTR_00000002 $00000002
#define PSTR_00000003 $00000003
#define PSTR_00000004 $00000004
#define PSTR_00000005 $00000005
#define PSTR_00000006 $00000006
#define PSTR_00000007 $00000007
#define PSTR_00000008 $00000008
#define PSTR_00000009 $00000009
#define PSTR_0000000A $0000000A
#define PSTR_0000000B $0000000B
#define PSTR_0000000C $0000000C
#define PSTR_0000000D $0000000D

// --- type $800B defines

#define Preferences_LEText $00000001
#define Permanently_LEText $00000002
#define If_duplicate_LEText $00000003
#define LETXTBOX_00000005 $00000005
#define About_LEText $00000006

// --- type $800E defines

#define Preferences_Window $00000FFA

// --- type $8015 defines

#define irDuplicateWontDie $00000001
#define irAboutAlert $00000002
#define irNoFinder $00000003

// --- type $801A defines

#define WindowRects $00000001
// --- type $8029 defines

#define IR_Version $00000001

// --- type $802A defines

#define Comment1 $00000001
#define Comment2 $00000002

// --- Icon Definitions

resource rIcon (IR_Init_Icon, preload) {
		$8000,				    // kind
		$0014,				    // height
		$0016,				    // width

		$"FFFFFFFFFFFFFFFFFFFFFF"
		$"FFFFFFFFFFFFFFFFFFFFFF"
		$"FFFF0000000FF0FFFFFFFF"
		$"FFFF0FFFFF0F0F0FFFFFFF"
		$"FFFF0F444F00F1F0FFFFFF"
		$"FFFF0F444F0F111F0FFFFF"
		$"FFFF0F444FF11111F0FFFF"
		$"FFFF0F444F1111111F0FFF"
		$"FFFF0F444FFF111FFFF0FF"
		$"00000F444F0F111F00000F"
		$"F0FFFF444FFF111F0FFFFF"
		$"FF0F4444444F111F0FFFFF"
		$"FFF0F44444FF111F0FFFFF"
		$"FFFF0F444F0F111F0FFFFF"
		$"FFFFF0F4F00F111F0FFFFF"
		$"FFFFFF0F0F0FFFFF0FFFFF"
		$"FFFFFFF0FF0000000FFFFF"
		$"FFFFFFFFFFFFFFFFFFFFFF"
		$"FFFFFFFFFFFFFFFFFFFFFF"
		$"FFFFFFFFFFFFFFFFFFFFFF",

		$"0000000000000000000000"
		$"0000000000000000000000"
		$"0000FFFFFFF00F00000000"
		$"0000FFFFFFF0FFF0000000"
		$"0000FFFFFFFFFFFF000000"
		$"0000FFFFFFFFFFFFF00000"
		$"0000FFFFFFFFFFFFFF0000"
		$"0000FFFFFFFFFFFFFFF000"
		$"0000FFFFFFFFFFFFFFFF00"
		$"FFFFFFFFFFFFFFFFFFFFF0"
		$"0FFFFFFFFFFFFFFFF00000"
		$"00FFFFFFFFFFFFFFF00000"
		$"000FFFFFFFFFFFFFF00000"
		$"0000FFFFFFFFFFFFF00000"
		$"00000FFFFFFFFFFFF00000"
		$"000000FFF0FFFFFFF00000"
		$"0000000F00FFFFFFF00000"
		$"0000000000000000000000"
		$"0000000000000000000000"
		$"0000000000000000000000";
};

// --- Control List Definitions

resource rControlList (Preferences_Ctl_List, $0000) {
		{
		Prefs_Title,		 // control 1
		Install_NDAs_now,		 // control 2
		Install_FEs_permanently,		 // control 3
		Permanently_stat_text,		 // control 4
		If_duplicate_stat_text,		 // control 5
		Install_new_Radio,		 // control 6
		Try_to_kill_old_Radio,		 // control 7
		Always_remove_old_Radio,		 // control 8
		Version_control,		 // control 9
		Accept,		 // control 10
		Cancel,		 // control 11
		Save,		 // control 12
		Open_NDAs_now,		 // control 13
		Do_OpenFailed,		 // control 14
		Do_Alerts_on_Problems,		 // control 15
		Underline,		 // control 16
		Big_Rectangle,		 // control 17
		};
};

// --- Control Templates

resource rControlTemplate (Prefs_Title, $0000) {
		$00000001,				// ID
		{  5, 10, 15,163},      // rect
		statTextControl {{
				 $0000,		   // flag
				 $1002,		   // moreFlags
				 $00000000,      // refCon
				 Preferences_LEText,     // textRef
				 Preferences_LEText_CNT, // textSize
				 $0000		    // just
		}};
};

resource rControlTemplate (Install_NDAs_now, $0000) {
		$00000002,				// ID
		{ 21, 14, 31,220},      // rect
		checkControl {{
				 $0000,		   // flag
				 $3002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_00000001,  // titleRef
				 $0001,		   // initialValue
				 0,				// colorTableRef
				 {"N","n",$0100,$0100}  // key equivalents
		}};
};

resource rControlTemplate (Install_FEs_permanently, $0000) {
		$00000003,				// ID
		{ 45, 14, 54,242},      // rect
		checkControl {{
				 $0000,		   // flag
				 $3002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_00000002,  // titleRef
				 $0000,		   // initialValue
				 0,				// colorTableRef
				 {"F","f",$0100,$0100}  // key equivalents
		}};
};

resource rControlTemplate (Permanently_stat_text, $0000) {
		$00000004,				// ID
		{ 54, 42, 63,135},      // rect
		statTextControl {{
				 $0004,		   // flag (blast text)
				 $1002,		   // moreFlags
				 $00000000,      // refCon
				 Permanently_LEText,     // textRef
				 Permanently_LEText_CNT, // textSize
				 $0000		    // just
		}};
};

resource rControlTemplate (If_duplicate_stat_text, $0000) {
		$00000005,				// ID
		{ 91, 22,101,253},      // rect
		statTextControl {{
				 $0004,		   // flag (blast text)
				 $1002,		   // moreFlags
				 $00000000,      // refCon
				 If_duplicate_LEText,     // textRef
				 If_duplicate_LEText_CNT, // textSize
				 $0000		    // just
		}};
};

resource rControlTemplate (Install_new_Radio, $0000) {
		$00000006,				// ID
		{106, 14,115,220},      // rect
		radioControl {{
				 $0000,		   // flag
				 $3002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_00000003,  // titleRef
				 $0001,		   // initialValue
				 0,				// colorTableRef
				 {"I","i",$0100,$0100}  // key equivalents
		}};
};

resource rControlTemplate (Try_to_kill_old_Radio, $0000) {
		$00000007,				// ID
		{116, 14,126,224},      // rect
		radioControl {{
				 $0000,		   // flag
				 $3002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_00000004,  // titleRef
				 $0000,		   // initialValue
				 0,				// colorTableRef
				 {"T","t",$0100,$0100}  // key equivalents
		}};
};

resource rControlTemplate (Always_remove_old_Radio, $0000) {
		$00000008,				// ID
		{126, 14,136,228},      // rect
		radioControl {{
				 $0000,		   // flag
				 $3002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_00000005,  // titleRef
				 $0000,		   // initialValue
				 0,				// colorTableRef
				 {"A","a",$0100,$0100}  // key equivalents
		}};
};

resource rControlTemplate (Version_control, $0000) {
		$00000009,				// ID
		{  5,181, 15,270},      // rect
		statTextControl {{
				 $0000,		   	// flag
				 $1000,		   	// moreFlags (ref is by POINTER)
				 $00000000,     // refCon
				 $00000000,     // textRef (NIL at first)
				 0, 			// textSize (no text at first)
				 $FFFF		    // just
		}};
};

resource rControlTemplate (Accept, $0000) {
		$0000000B,				// ID
		{143,194,156,270},      // rect
		simpleButtonControl {{
				 $0001,		   // flag
				 $3002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_00000006,  // titleRef
				 0,				// colorTableRef
				 {"\$0D", "\$0D",$0000,$0000}  // key equivalents
		}};
};

resource rControlTemplate (Cancel, $0000) {
		$0000000C,				// ID
		{143,112,156,188},      // rect
		simpleButtonControl {{
				 $0000,		   // flag
				 $3002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_00000007,  // titleRef
				 0,				// colorTableRef
				 {"\$1B", "\$1B",$0000,$0000}  // key equivalents
		}};
};

resource rControlTemplate (Save, $0000) {
		$0000000D,				// ID
		{143, 14,156, 90},      // rect
		simpleButtonControl {{
				 $0000,		   // flag
				 $3002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_00000008,  // titleRef
				 0,				// colorTableRef
				 {"S","s",$0100,$0100}  // key equivalents
		}};
};

resource rControlTemplate (Open_NDAs_now, $0000) {
		$0000000E,				// ID
		{ 33, 14, 42,234},      // rect
		checkControl {{
				 $0000,		   // flag
				 $1002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_00000009,  // titleRef
				 $0001		    // initialValue
		}};
};

resource rControlTemplate (Do_OpenFailed, $0000) {
		$0000000F,				// ID
		{ 66, 14, 75,248},      // rect
		checkControl {{
				 $0000,		   // flag
				 $1002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_0000000A,  // titleRef
				 $0000		    // initialValue
		}};
};

resource rControlTemplate (Do_Alerts_on_Problems, $0000) {
		$00000010,				// ID
		{ 78, 14, 87,264},      // rect
		checkControl {{
				 $0000,		   // flag
				 $1002,		   // moreFlags
				 $00000000,      // refCon
				 PSTR_0000000B,  // titleRef
				 $0001		    // initialValue
		}};
};

resource rControlTemplate (Underline, $0000) {
		$00000011,				// ID
		{ 16, 10, 17,270},      // rect
 		rectangleControl {{
				 $FF02,		   // flag
				 $1000,		   // moreFlags
				 $00000000      // refCon
		}};
};

resource rControlTemplate (Big_Rectangle, $0000) {
		$00000012,				// ID
		{ 97,  8,139,272},      // rect
 		rectangleControl {{
				 $FF01,		   // flag
				 $1000,		   // moreFlags
				 $00000000     // refCon
		}};
};

// --- rPString Templates

resource rPString (PSTR_00000001, $0000) {
		"Install NDAs instantly"
};

resource rPString (PSTR_00000002, $0000) {
		"Install Finder extensions"
};

resource rPString (PSTR_00000003, $0000) {
		"Install a new copy"
};

resource rPString (PSTR_00000004, $0000) {
		"Try to remove the old one"
};

resource rPString (PSTR_00000005, $0000) {
		"Always remove the old one"
};

resource rPString (PSTR_00000006, $0000) {
		"Accept"
};

resource rPString (PSTR_00000007, $0000) {
		"Cancel"
};

resource rPString (PSTR_00000008, $0000) {
		"Save"
};

resource rPString (PSTR_00000009, $0000) {
		"Open NDAs if possible"
};

resource rPString (PSTR_0000000A, $0000) {
		"Give others first shot at files"
};

resource rPString (PSTR_0000000B, $0000) {
		"Tell me about problems"
};

resource rPString (PSTR_0000000C, $0000) {
		"Button"
};

resource rPString (PSTR_0000000D, $0000) {
		"Button"
};

// --- rTextForLETextBox2 Templates

resource rTextForLETextBox2 (Preferences_LEText, $0000) {
		TBStyleBold
		"IR Preferences"
};

resource rTextForLETextBox2 (Permanently_LEText, $0000) {
		"permanently"
};

resource rTextForLETextBox2 (If_duplicate_LEText, $0000) {
		"If you choose an installed file"
};

// --- Window Templates

resource rWindParam1 (Preferences_Window, locked) {
		$208A,				    // plFrame (frame bits)
		NIL,				      // plTitle (no Title)
		$00000000,				// plRefCon
		{  0,  0,  0,  0},      // plZoomRect
		NIL,				      // plColorTable (standard colors)
		{$0000, $0000},		  // plYOrigin, plXOrigin
		{$0000, $0000},		  // plDataHeight, plDataWidth
		{$0000, $0000},		  // plMaxHeight, plMaxWidth
		{$0000, $0000},		  // plVerScroll, plHorScroll
		{$0000, $0000},		  // plVerPage, plHorPage
		$00000000,				// plInfoText (info RefCon)
		$0000,				    // plInfoHeight
		{ 28,180,190,460},      // plPosition
		infront,				  // plPlane
		Preferences_Ctl_List,		 // plControlList
		$0009				     // plInDesc
};

// --- rAlertString Templates

resource rAlertString (irDuplicateWontDie, $0000) {
		"74~This item is already installed and IR can"
		"\$D5"
		"t remove the currently installed version.  What do you want to d"
		"o?~^#1~Install another copy"
		"\$00"
};

resource rAlertString (irAboutAlert, locked, NoCrossBank) {
		"0XXYYxxyy"						// custom size
		"1"								// custom icon
		"\$01\$00\$00\$00"				// our Icon resource ID ($00000002)
		"~"
		TBCenterJust
		TBFont
		TBShaston
		"\$01\$08"
		TBStyleBold
		TBEndOfLine
		"IR"
		TBEndOfLine
	    TBStylePlain
		TBEndOfLine
		"The multi-purpose, on-the-fly "
		"component installer thingy."
		TBEndOfLine
		TBEndOfLine
		"By Matt Deatherage"
		TBEndOfLine
		TBEndOfLine
		"Copyright 1991-1992, Apple Computer, Inc.  "
		"All Rights Reserved."
		TBEndOfLine
		TBEndOfLine
		"Special thanks to Dave Lyons, "
		"Andy Nicholas and the one and "
		"thankfully only Tim Swihart"
		TBEndOfLine
		"(the first)."
	   "~"
	   "^Cool"
	   "\$00"
};
		

resource rAlertString (irNoFinder, $0000) {
		"73~Installing Finder Extensions will probably have no effect unl"
		"ess you return to the Finder before rebooting your Apple IIgs co"
		"mputer.  Install them anyway?~#1~^Install"
		"\$00"
};

resource rVersion (0x1) {
	{
		0x2,
		0x0,
		0x0,
		release,
		0x0
	},
	verUS,
	"IR",
	"Copyright 1989-92 Apple Computer, Inc."
};

resource rComment (0x1) {
	"IR lets you install desk accessories, "
	"system setup files, Finder Extensions and "
	"some GS/OS drivers from the Finder (or "
	"some other programs) without rebooting.\n\n"
	"Written by Matt Deatherage, Developer "
	"Technical Support, Apple Computer, Inc.  "
	"Thanks to Andy Nicholas, Tim Swihart and "
	"(of course) to Dave Make it do everything I "
	"want Lyons."
};

resource rComment (0x2) {
	"IR lets you double-click on system setup "
	"files (like this one), desk accessories, "
	"some GS/OS drivers and Finder Extensions "
	"to install them without rebooting.  "
	"Unfortunately, you have to install IR in "
	"the normal way to make it work.  Put this "
	"file in the System.Setup folder in the "
	"System folder of your startup volume and "
	"restart your Apple IIgs computer."
};

resource rTwoRects (WindowRects,Locked,noCrossBank) {
	{25,20,187,300},	// window rect for 320 mode
	{25,180,187,460}	// window rect for 640 mode
};


