/*******************************************************************************
*
* IR.h -- C interface file for IR v2.0
*
* by Matt Deatherage
*
* Copyright 1991-1992, Apple Computer, Inc.  All rights reserved.
*
* Release history:
*
* 2.0f1			Matt Deatherage		2/24/92
*
* First release.
*
* 2.0			Matt Deatherage		2/25/92
* Changed relative numbers to be absolute.
*
*******************************************************************************/

#ifndef __TYPES__
#include <TYPES.h>
#endif

#ifndef __GSOS__
#include <GSOS.h>
#endif

#ifndef __IR__
#define __IR__

#define NAME_OF_IR "\pApple~IR~"

#define irRequestBase 0xC300

#define askIRStartUp 		0xC300 /* don't call this */
#define askIRAreYouThere 	0xC301
#define askIRToInstall 		0xC302
#define askIRGetPrefs 		0xC303
#define askIRSetPrefs 		0xC304
#define askIRDoPrefs 		0xC305

#define /* Error codes */

#define irErrorMask 0xFF00
#define irErrorBase 0xC300

#define irDuplicateExists 	0xC301
#define irDuplicateWontDie 	0xC302
#define irNoFinder 			0xC303
#define irGSOSNotAvail 		0xC304
#define irNotIRFile 		0xC305
#define irBusy 				0xC306
#define irCantPrint 		0xC307

#define /* flag bits */

#define irDefaultPrefs 		0
#define irSpecialPrefs 		0x0001
#define irDoDiskPrefs 		0x0001
#define irNoDuplicates 		0x0002
#define irKillDuplicates 	0x0004
#define irDontOpenNDAs 		0x0008
#define irKillFinderExts 	0x0010
#define irCopyExistNDAs 	0x0020
#define irWaitOpenFailed 	0x0040
#define irIgnoreProblems 	0x0080

typedef struct IRStartUpRecord {
	int userID;
} IRStartUpRecord, *IRStartUpRecordPtr, **IRStartUpRecordHndl;


typedef struct IRInputRecord {
	int recvCount;
	int userID;
} IRInputRecord, *IRInputRecordPtr, **IRInputRecordHndl;
			
typedef struct askInstallInputRecord {
	int flags;
	GSString255Ptr pathname;
	int filetype;
	longint auxtype;
} askInstallInputRecord, *askInstallInputRecordPtr, **askInstallInputRecordHndl;

typedef struct askInstallOutputRecord {
	int recvCount;
	int irError;
	int userID;
} askInstallOutputRecord, *askInstallOutputRecordPtr, **askInstallOutputRecordHndl;

typedef struct askGetPrefsOutputRecord {
	int recvCount;
	int irError;
	int preferences;
} askGetPrefsOutputRecord, *askGetPrefsOutputRecordPtr, **askGetPrefsOutputRecordHndl;

typedef struct askSetPrefsOutputRecord {
	int recvCount;
	int irError;
} askSetPrefsOutputRecord, *askSetPrefsOutputRecordPtr, **askSetPrefsOutputRecordHndl;
											  
