{******************************************************************************
*
* IR.p -- Pascal interface file for IR v2.0
*
* by Matt Deatherage
*
* Copyright 1991-1992, Apple Computer, Inc.  All rights reserved.
*
* Release history:
*
* 2.0a3		Matt Deatherage (12/11/91)
*
* First release.
*
* 2.0b1		Matt Deatherage (02/19/92)
*
* Added IRInfoRecord to have the newly-returned user ID.
*
* 2.0b3		Matt Deatherage (02/21/92)
*
* Changed the copyright dates.
*
* 2.0f1		Matt Deatherage (02/24/92)
*
* Changed IRInputRecord (again) to reflect the version longint now in it.
*
* 2.0			Matt Deatherage (02/25/92)
*
* Changed relative numbers to be absolute.
*
*
******************************************************************************}

{[j=12-/32/80!,o=95,a-]}		 {PasMat options}
UNIT IR;

	INTERFACE

		USES TYPES,GSOS;

		PROCEDURE dummy;

		CONST
			{IR Requests}
			irRequestBase = $C300;

			askIRStartUp = $C300; { don't call this }
			askIRAreYouThere = $C301;
			askIRToInstall = $C302;
			askIRGetPrefs = $C303;
			askIRSetPrefs = $C304;
			askIRDoPrefs = $C305;

			{ Error codes }

			irErrorMask = $FF00;
			irErrorBase = $C300;

			irDuplicateExists = $C301;
			irDuplicateWontDie = $C302;
			irNoFinder	= $C303;
			irGSOSNotAvail = $C304;
			irNotIRFile = $C305;
			irBusy		= $C306;
			irCantPrint = $C307;

			{ flag bits }

			irDefaultPrefs = 0;
			irSpecialPrefs = $0001;
			irDoDiskPrefs = $0001;
			irNoDuplicates = $0002;
			irKillDuplicates = $0004;
			irDontOpenNDAs = $0008;
			irKillFinderExts = $0010;
			irCopyExistNDAs = $0020;
			irWaitOpenFailed = $0040;
			irIgnoreProblems = $0080;

		TYPE

			startUpRecord = RECORD
									 userID: integer;
								 END;

			IRInputRecord = RECORD
								 	 recvCount: integer;
									 userID : integer;
									 version : longint;
							    END;
			
			askInstallInputRecord = RECORD
												flags: integer;
												pathname: gsstring255ptr;
												filetype: integer;
												auxtype: longint;
											END;

			askInstallOutputRecord = RECORD
												 recvCount: integer;
												 irError: integer;
												 userID: integer;
											 END;

			askGetPrefsOutputRecord = RECORD
												  recvCount: integer;
												  irError: integer;
												  preferences: integer;
											  END;

			askSetPrefsOutputRecord = RECORD
												  recvCount: integer;
												  irError: integer;
											  END;
											  
	IMPLEMENTATION

END.
