//###########################################################
//#															#
//#	File:			CDEV.r									#
//#	Version:		3.0										#
//#	Author:													#
//#	Copyright:		(c) 1989-1990 by Apple Computer, Inc.	#
//#	Developer Technical Support Apple II Sample Code		#
//#															#
//#	Description:	This file contains the resource			#
//#					definitions used by the Shell CDEV		#
//#															#
//#---------------------------------------------------------#
//#															#
//#	Development History:									#
//#															#
//#	Who		Date		The Modification					#
//#	---		--------	----------------					#
//#															#
//###########################################################

//###########################################################
//#		Read any standard includes & define our own			#
//###########################################################

#include "typesiigs.r"	//	include the type definitions

//###########################################################
//#		Read the resources built elsewhere					#
//###########################################################

read rCDEVCode (1, Convert) "CDevCode";	// this is the code resource

//###########################################################
//#		Define our resources								#
//###########################################################

resource rCDEVFlags (1) {
	wantHit+wantInit+wantCreate+wantAbout+canBeInactive,	// CDEV flags
	1,								//	enabled = True
	1,								//	Version = 1
	1,								//	Machine = v1 ROMs or higher
	5,								//	System = v5.0 or higher
	{0,0,47,200},					//	DataRect - top left MUST be 0,0
	"CDev",							//	Name
	"Your Name Here",				//	Author
	"v3.0";							//	Version String
};

//###########################################################
//#		Define icon resources								#
//###########################################################

resource rIcon (1) {				//	the "CDEV" icon
	0x8000,							//	kind
	20,								//	height
	28,								//	width
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FF7777FF11111FFBBBBBFDDFFDDF"
	$"F777777F111111FBBBBBFDDFFDDF"
	$"F77FF77F11FF11FBBFFFFDDFFDDF"
	$"F77FFFFF11FF11FBBBBFFDDFFDDF"
	$"F77FFFFF11FF11FBBBBFFDDFFDDF"
	$"F77FF77F11FF11FBBFFFFDDFFDDF"
	$"F777777F111111FBBBBBFFDDDDFF"
	$"FF7777FF11111FFBBBBBFFFDDFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF"
	$"FFFFFFFFFFFFFFFFFFFFFFFFFFFF",
	
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
	$"00FFFF00FFFFF00FFFFF0FF00FF0"
	$"0FFFFFF0FFFFFF0FFFFF0FF00FF0"
	$"0FF00FF0FF00FF0FF0000FF00FF0"
	$"0FF00000FF00FF0FFFF00FF00FF0"
	$"0FF00000FF00FF0FFFF00FF00FF0"
	$"0FF00FF0FF00FF0FF0000FF00FF0"
	$"0FFFFFF0FFFFFF0FFFFF00FFFF00"
	$"00FFFF00FFFFF00FFFFF000FF000"
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
	$"0000000000000000000000000000"
};