/********************************************
; File: Scrap.h
;
;
; Copyright Apple Computer, Inc. 1986-91
; All Rights Reserved
;
********************************************/
#ifndef __TYPES__
#include <TYPES.h>
#endif

#ifndef __SCRAP__
#define __SCRAP__


/* Error Codes */
#define badScrapType 0x1610  /* No scrap of this type. */

/* Scrap Types */
#define textScrap 0x0000
#define picScrap 0x0001
#define sampledSoundScrap 0x0002
#define teStyleScrap 0x0064
#define iconScrap 0x4945
#define maskScrap 0x8001
#define colorTableScrap 0x8002
#define resourceRefScrap 0x8003

typedef struct scrapInfo {
    Word scrapType;
	LongWord scrapSize;
	Handle scrapHandle;
} ;
typedef struct scrapInfo scrapInfo, *scrapInfoPtr, **scrapInfoHndl;

extern pascal void GetScrap() inline(0x0D16,dispatcher);
extern pascal Word GetScrapCount() inline(0x1216,dispatcher);
extern pascal handle GetScrapHandle() inline(0x0E16,dispatcher);
extern pascal Pointer GetScrapPath() inline(0x1016,dispatcher);
extern pascal LongWord GetScrapSize() inline(0x0F16,dispatcher);
extern pascal Word GetScrapState() inline(0x1316,dispatcher);
extern pascal void LoadScrap() inline(0x0A16,dispatcher);
extern pascal void PutScrap() inline(0x0C16,dispatcher);
extern pascal void ScrapBootInit() inline(0x0116,dispatcher);
extern pascal void ScrapReset() inline(0x0516,dispatcher);
extern pascal void ScrapShutDown() inline(0x0316,dispatcher);
extern pascal void ScrapStartUp() inline(0x0216,dispatcher);
extern pascal Boolean ScrapStatus() inline(0x0616,dispatcher);
extern pascal Word ScrapVersion() inline(0x0416,dispatcher);
extern pascal void SetScrapPath() inline(0x1116,dispatcher);
extern pascal void UnloadScrap() inline(0x0916,dispatcher);
extern pascal void ZeroScrap() inline(0x0B16,dispatcher);

extern pascal void GetIndScrap() inline(0x1416,dispatcher);

#endif
