#   File:       SCSIxx.Driver.make
#   Target:     SCSIxx.Drvr
#   Sources:    'SCSI Driver main'
#               'SCSI Command Table'
#               'SCSI Filter startup'
#               'SCSI Filter open'
#               'SCSI Filter read'
#               'SCSI Filter write'
#               'SCSI Filter close'
#               'SCSI Filter status'
#               'SCSI Filter control'
#               'SCSI Filter flush'
#               'SCSI Filter shutdown'
#               'SCSI Main Driver'
#               'SCSI Driver Mgmt'
#   Created:    Wednesday, January 3, 1990 6:48:18 AM
#  Modified:    Wednesday, January 3, 1990 6:48:18 AM
#
#	This Make File can be modified by changing the 'xx' to the type
#	of device that the driver is for.  There must be rules in the
#	SCSI.Equates file that account for type=n where n is any integer
#	that has not already been defined in the Equates file..
#

SCSIxx.Driver  SCSIxx.Driver.make 
		:xx.Obj:'SCSIxx Driver main.obj' 
		:xx.Obj:'SCSIxx Command Table.obj' 
		:xx.Obj:'SCSIxx Filter startup.obj' 
		:xx.Obj:'SCSIxx Filter open.obj' 
		:xx.Obj:'SCSIxx Filter read.obj' 
		:xx.Obj:'SCSIxx Filter write.obj' 
		:xx.Obj:'SCSIxx Filter close.obj' 
		:xx.Obj:'SCSIxx Filter status.obj' 
		:xx.Obj:'SCSIxx Filter control.obj' 
		:xx.Obj:'SCSIxx Filter flush.obj' 
		:xx.Obj:'SCSIxx Filter shutdown.obj' 
		:xx.Obj:'SCSIxx Main Driver.obj' 
		:xx.Obj:'SCSIxx Driver Mgmt.obj'
    LinkIIGS -t $bb -at $0103 
		:xx.Obj:'SCSIxx Driver main.obj' 
		:xx.Obj:'SCSIxx Command Table.obj' 
		:xx.Obj:'SCSIxx Filter startup.obj' 
		:xx.Obj:'SCSIxx Filter open.obj' 
		:xx.Obj:'SCSIxx Filter read.obj' 
		:xx.Obj:'SCSIxx Filter write.obj' 
		:xx.Obj:'SCSIxx Filter close.obj' 
		:xx.Obj:'SCSIxx Filter status.obj' 
		:xx.Obj:'SCSIxx Filter control.obj' 
		:xx.Obj:'SCSIxx Filter flush.obj' 
		:xx.Obj:'SCSIxx Filter shutdown.obj' 
		:xx.Obj:'SCSIxx Main Driver.obj' 
		:xx.Obj:'SCSIxx Driver Mgmt.obj' 
		-o ':xx.Obj:SCSIxx.Driver.lnk'
	ExpressIIGS 
		':xx.Obj:SCSIxx.Driver.lnk' 
		-o 'SCSIxx.Drvr'
	duplicateiigs -y -m SCSIxx.Drvr SCSIxx.Drvr
:xx.Obj:'SCSIxx Driver main.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Driver main' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Driver main' 
		-o :xx.Obj:'SCSIxx Driver main.obj'
:xx.Obj:'SCSIxx Command Table.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Command Table' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Command Table' 
		-o :xx.Obj:'SCSIxx Command Table.obj'
:xx.Obj:'SCSIxx Filter startup.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Filter startup' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Filter startup' 
		-o :xx.Obj:'SCSIxx Filter startup.obj'
:xx.Obj:'SCSIxx Filter open.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Filter open' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Filter open' 
		-o :xx.Obj:'SCSIxx Filter open.obj'
:xx.Obj:'SCSIxx Filter read.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Filter read' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Filter read' 
		-o :xx.Obj:'SCSIxx Filter read.obj'
:xx.Obj:'SCSIxx Filter write.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Filter write' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Filter write' 
		-o :xx.Obj:'SCSIxx Filter write.obj'
:xx.Obj:'SCSIxx Filter close.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Filter close' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Filter close' 
		-o :xx.Obj:'SCSIxx Filter close.obj'
:xx.Obj:'SCSIxx Filter status.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Filter status' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Filter status' 
		-o :xx.Obj:'SCSIxx Filter status.obj'
:xx.Obj:'SCSIxx Filter control.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Filter control' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Filter control' 
		-o :xx.Obj:'SCSIxx Filter control.obj'
:xx.Obj:'SCSIxx Filter flush.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Filter flush' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Filter flush' 
		-o :xx.Obj:'SCSIxx Filter flush.obj'
:xx.Obj:'SCSIxx Filter shutdown.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Filter shutdown' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Filter shutdown' 
		-o :xx.Obj:'SCSIxx Filter shutdown.obj'
:xx.Obj:'SCSIxx Main Driver.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Main Driver' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Main Driver' 
		-o :xx.Obj:'SCSIxx Main Driver.obj'
:xx.Obj:'SCSIxx Driver Mgmt.obj'  
		'SCSIxx.Driver.make' 
		'SCSI Driver Mgmt' 
		'SCSIHD.equates'
	AsmIIGS -d &type,type=n 'SCSI Driver Mgmt' 
		-o :xx.Obj:'SCSIxx Driver Mgmt.obj'
