{********************************************
; File: Desk.p
;
;
; Copyright Apple Computer, Inc. 1986-91
; All Rights Reserved
;
********************************************}

UNIT DESK;

INTERFACE

USES TYPES, QUICKDRAW, EVENTS, CONTROLS, WINDOWS;

CONST
{ Error Codes }
daNotFound = $0510;  { desk accessory not found }
notSysWindow = $0511;  { not the system window }
deskBadSelector = $0520; { bad selector for GetDeskAccInfo }

{ NDA Action Codes }
eventAction = $0001;
runAction = $0002;
cursorAction = $0003;
undoAction = $0005;
cutAction = $0006;
copyAction = $0007;
pasteAction = $0008;
clearAction = $0009;
sysClickAction = $000A;
optionalCloseAction = $000B;

{ SystemEdit Codes }
undoEdit = $0001;
cutEdit = $0002;
copyEdit = $0003;
pasteEdit = $0004;
clearEdit = $0005;

{ GetDeskAccInfo constants }
getCDAinfo = $8000;
getNDAinfo = $0000;
daRefIsWindPtr = $0001;
daRefIsIndex = $0000;

{ GetDeskGlobal constants }
deskGlobalWindow = $0000;

{ CallDeskAcc constants }
daCallCDA = $8000;
daCallNDA = $0000;
daCallInit = $0002;
daCallAction = $0000;
{ daRefIsWindPtr = $0001; }
{ daRefIsIndex = $0000; }

TYPE
NDASysWindRecPtr = ^NDASysWindRecord;
NDASysWindRecord = RECORD
	status: integer; { use 0, reserved for Desk Mgr }
	openProc: LongProcPtr; { reserved, use nil }
	closeProc: ProcPtr; { pointer to your Close routine }
	actionProc: ProcPtr; { pointer to your Action routine }
	initProc: ProcPtr; { reserved, use nil }
	period: integer;
	eventMask: integer; { your event mask, like for an NDA }
	lastServiced: longint; { reserved, use 0 }
	windowPtr: longint; { reserved, use 0 }
	ndaHandle: longint; { reserved, use 0 }
	memoryID: integer; { your memory ID, important! }
END;

PROCEDURE AddToRunQ ( runItemPtr:Ptr);
PROCEDURE ChooseCDA;
PROCEDURE CloseAllNDAs;
PROCEDURE CloseNDA ( refNum:Integer);
PROCEDURE CloseNDAByWinPtr ( theWindowPtr:WindowPtr);
PROCEDURE DeskBootInit;
PROCEDURE DeskReset;
PROCEDURE DeskShutDown;
PROCEDURE DeskStartUp;
FUNCTION  DeskStatus: Boolean;
FUNCTION  DeskVersion: Integer;
PROCEDURE FixAppleMenu(startingID:Integer);
FUNCTION  GetDAStrPtr: Ptr;
FUNCTION  GetNumNDAs: Integer;
PROCEDURE InstallCDA(idHandle:Handle);
PROCEDURE InstallNDA(idHandle:Handle);
FUNCTION  OpenNDA(idNum:Integer): Integer;
PROCEDURE RemoveCDA(idHandle:Handle);
PROCEDURE RemoveFromRunQ(runItemPtr:Ptr);
PROCEDURE RemoveNDA(idHandle:Handle);
PROCEDURE RestAll;
PROCEDURE RestScrn;
PROCEDURE SaveAll;
PROCEDURE SaveScrn;
PROCEDURE SetDAStrPtr(altDispHandle:Handle; stringTablePtr:Ptr);
PROCEDURE SystemClick(eventRecPtr:EventRecord; theWindowPtr:GrafPortPtr; findWndwResult:Integer);
FUNCTION  SystemEdit(editType:Integer) : Boolean;
FUNCTION  SystemEvent(eventWhat:Integer; eventMessage:Longint; eventWhen:Longint; eventWhere:Point; eventMods:Integer) : Boolean;
PROCEDURE SystemTask;

PROCEDURE GetDeskAccInfo(flags:integer; daReference:Ref; buffSize:integer; bufferPtr:Ptr);
FUNCTION CallDeskAcc(flags:integer; daReference:Ref; action:integer; data:longint):integer;
FUNCTION GetDeskGlobal(selector:integer):longint;

IMPLEMENTATION

END.
