/********************************************************************************
								new.controls.c
	This file contains global data defining controls that are used in testing. 
	These templates are for extended controls.
	
*********************************************************************************/


#include <types.h>
#include <quickdraw.h>
#include <control.h>
#define mtItemRefArrayLength 50
#include <menu.h>
#include <TextEdit.h>
#include "finder.h"


/************************************************************************************************/

/* Here's the controls for entering a pathname */

char	PathnameTextString[] = "\pEnter complete Pathname beginning with ':'";

StaticTextTemplate PathnameStatText =	{9,
										0x00000400L,
										{8,10,18,440},
										statTextControl,
										0x0003,
										0x1000,
										0L,
										(Long)PathnameTextString,
										43,
										1};

TextEditTemplate	PathnameTextEdit = 	{16,
										0x00000401L,
										{18,10,40,440},
										editTextControl,
										0x0000,
										0x7400,
										0L,
										0x49800000L,
										{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
										0L,
										0x0000,
										0L,
										0,
										0L,
										0,
										0L,
										1L};

/************************************************************************************************/		

/* Here's the pop-up menu and menuitems for installing and removing request procs */

MenuItemTemplate Hello = 				{0,
										0x0100,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysHello"};
													
MenuItemTemplate Goodbye = 				{0,
										0x0101,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysGoodbye"};
													
MenuItemTemplate SelectionChanged = 	{0,
										0x0102,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysSelectionChanged"};
													
MenuItemTemplate MItemSelected = 		{0,
										0x0103,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysMItemSelected"};

MenuItemTemplate BeforeOpen = 			{0,
										0x0104,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysBeforeOpen"};

MenuItemTemplate OpenFailed = 			{0,
										0x0105,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysOpenFailed"};

MenuItemTemplate BeforeCopy = 			{0,
										0x0106,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysBeforeCopy"};

MenuItemTemplate Idle = 				{0,
										0x0107,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysIdle"};

MenuItemTemplate ExtrasChosen = 		{0,
										0x0108,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysExtrasChosen"};
													
MenuItemTemplate BeforeRename = 		{0,
										0x0109,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysBeforeRename"};

MenuItemTemplate KeyHit = 				{0,
										0x010A,
										0,
										0,
										0,
										0x0000,
										(Long)"\pfinderSaysKeyHit"};

MenuItemTemplate RemoveReqProcs = 		{0,
										0x010B,
										0,
										0,
										0,
										0x0000,
										(Long)"\pRemove Request Procs"};

char finderSaysPopUpTitleString[] = "\pfinderSays";

MenuTemplate AcceptRequestsPopUpMenuTemplate =		{0,
													0x0010,
													0x0000,
													(Long)finderSaysPopUpTitleString,
													{(Long)&Hello,
													(Long)&Goodbye,
													(Long)&SelectionChanged,
													(Long)&MItemSelected,
													(Long)&BeforeOpen,
													(Long)&OpenFailed,
													(Long)&BeforeCopy,
													(Long)&Idle,
													(Long)&ExtrasChosen,
													(Long)&BeforeRename,
													(Long)&KeyHit,
													(Long)&RemoveReqProcs,
													0x00000000L}};

PopupTemplate	AcceptRequestsPopUp =	{9,
										0x00000100L,
										{50,10,0,0},
										popUpControl,
										0x0060,
										0x3080,
										0L,
										120,
										(Long)&AcceptRequestsPopUpMenuTemplate,
										0x0100};

/************************************************************************************************/

/* Define all the FinderRequests menu items, menu, and popup control to display menu. */

MenuItemTemplate GetDebugInfo = 				{0,
												0x8000,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderGetDebugInfo"};

MenuItemTemplate AreYouThere = 					{0,
												0x8001,
												0,
												0,
												0,
												0x0000,
												(Long)"\paskFinderAreYouThere"};

MenuItemTemplate OpenWindow = 					{0,
												0x8002,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderOpenWindow"};

MenuItemTemplate _CloseWindow = 					{0,
												0x8003,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderCloseWindow"};

MenuItemTemplate GetSelectedIcons = 			{0,
												0x8004,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderGetSelectedIcons"};

MenuItemTemplate SetSelectedIcons = 			{0,
												0x8005,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderSetSelectedIcons"};

MenuItemTemplate LaunchThisAp = 				{0,
												0x8006,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderLaunchThis(Ap)"};

MenuItemTemplate ShutDownOff = 					{0,
												0x807A,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderShutDown(Off)"};

MenuItemTemplate ShutDownRestart =				{0,
												0x807B,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderShutDown(Restart)"};

MenuItemTemplate ShutDownQuit =					{0,
												0x807C,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderShutDown(Quit)"};

MenuItemTemplate MatchFileToIcon = 				{0,
												0x800A,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderMatchFileToIcon"};

MenuItemTemplate AddBundle = 					{0,
												0x800B,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderAddBundle"};

MenuItemTemplate AboutChange = 					{0,
												0x800C,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderAboutChange"};

MenuItemTemplate AboutDatabase = 				{0,
												0x800D,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderAboutDatabase"};

MenuItemTemplate AddToExtras = 					{0,
												0x800F,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderAddToExtras"};

MenuItemTemplate IdleHowLong = 					{0,
												0x8011,
												0,
												0,
												0,
												0x0000,
												(Long)"\paskFinderIdleHowLong"};

MenuItemTemplate GetWindowIcons = 				{0,
												0x8012,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderGetWindowIcons"};

MenuItemTemplate GetWindowInfo = 				{0,
												0x8013,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderGetWindowInfo"};

MenuItemTemplate RemoveFromExtras = 			{0,
												0x8014,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderRemoveFromExtras"};

MenuItemTemplate SpecialPreferences = 			{0,
												0x8015,
												0,
												0,
												0,
												0x0000,
												(Long)"\ptellFinderSpecialPreferences"};

char tellFinderPopUpTitleString[] = "\ptellFinder";

MenuTemplate SendRequestsPopUpMenuTemplate =	{0,
												0x0080,
												0x0000,
												(Long)tellFinderPopUpTitleString,
												{(Long)&GetDebugInfo,
												(Long)&AreYouThere,
												(Long)&OpenWindow,
												(Long)&_CloseWindow,
												(Long)&GetSelectedIcons,
												(Long)&SetSelectedIcons,
												(Long)&LaunchThisAp,
												(Long)&ShutDownOff,
												(Long)&ShutDownRestart,
												(Long)&ShutDownQuit,
												(Long)&MatchFileToIcon,
												(Long)&AddBundle,
												(Long)&AboutChange,
												(Long)&AboutDatabase,
												(Long)&AddToExtras,
												(Long)&IdleHowLong,
												(Long)&GetWindowIcons,
												(Long)&GetWindowInfo,
												(Long)&RemoveFromExtras,
												(Long)&SpecialPreferences,
												0x00000000L}};

PopupTemplate	SendRequestsPopUp =	{9,
									0x00000800L,
									{70,10,0,0},
									popUpControl,
									0x0060,
									0x3080,
									0L,
									120,
									(Long)&SendRequestsPopUpMenuTemplate,
									0x8000};

/************************************************************************************************/

/* Here's the tellFinerMItemSelected pop-up menu and menu items */

MenuItemTemplate finderItemAboutID = 				{0,
													finderItemAbout,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemAbout"};

MenuItemTemplate finderItemHelpID = 				{0,
													finderItemHelp,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemHelp"};

MenuItemTemplate finderItemNewFolderID = 			{0,
													finderItemNewFolder,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemNewFolder"};

MenuItemTemplate finderItemOpenID = 				{0,
													finderItemOpen,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemOpen"};

MenuItemTemplate finderItemPrintID = 				{0,
													finderItemPrint,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemPrint"};

MenuItemTemplate finderItemCloseID = 				{0,
													finderItemClose,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemClose"};

MenuItemTemplate finderItemCloseAllID = 			{0,
													finderItemCloseAll,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemCloseAll"};

MenuItemTemplate finderItemDuplicateID = 			{0,
													finderItemDuplicate,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemDuplicate"};

MenuItemTemplate finderItemPutAwayID = 				{0,
													finderItemPutAway,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemPutAway"};

MenuItemTemplate finderItemValidateID = 			{0,
													finderItemValidate,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemValidate"};

MenuItemTemplate finderItemUndoID = 				{0,
													finderItemUndo,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemUndo"};

MenuItemTemplate finderItemCutID = 					{0,
													finderItemCut,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemCut"};

MenuItemTemplate finderItemCopyID = 				{0,
													finderItemCopy,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemCopy"};

MenuItemTemplate finderItemPasteID = 				{0,
													finderItemPaste,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemPaste"};

MenuItemTemplate finderItemClearID = 				{0,
													finderItemClear,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemClear"};

MenuItemTemplate finderItemSelectAllID = 			{0,
													finderItemSelectAll,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemSelectAll"};

MenuItemTemplate finderItemShowClipboardID = 		{0,
													finderItemShowClipboard,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemShowClipboard"};

MenuItemTemplate finderItemStackWindowsID = 		{0,
													finderItemStackWindows,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemStackWindows"};

MenuItemTemplate finderItemByIconID = 				{0,
													finderItemByIcon,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemByIcon"};

MenuItemTemplate finderItemBySmallIconID = 			{0,
													finderItemBySmallIcon,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemBySmallIcon"};

MenuItemTemplate finderItemByNameID = 				{0,
													finderItemByName,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemByName"};

MenuItemTemplate finderItemByDateID = 				{0,
													finderItemByDate,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemByDate"};

MenuItemTemplate finderItemBySizeID = 				{0,
													finderItemBySize,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemBySize"};

MenuItemTemplate finderItemByKindID = 				{0,
													finderItemByKind,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemByKind"};

MenuItemTemplate finderItemFormatID = 				{0,
													finderItemFormat,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemFormat"};

MenuItemTemplate finderItemEraseID = 				{0,
													finderItemErase,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemErase"};

MenuItemTemplate finderItemVerifyID = 				{0,
													finderItemVerify,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemVerify"};

MenuItemTemplate finderItemEjectID = 				{0,
													finderItemEject,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemEject"};

MenuItemTemplate finderItemCleanUpID = 				{0,
													finderItemCleanUp,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemCleanUp"};

MenuItemTemplate finderItemEmptyTrashID = 			{0,
													finderItemEmptyTrash,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemEmptyTrash"};

MenuItemTemplate finderItemPreferencesID = 			{0,
													finderItemPreferences,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemPreferences"};

MenuItemTemplate finderItemIconInfoID = 			{0,
													finderItemIconInfo,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemIconInfo"};

MenuItemTemplate finderItemShutDownID = 			{0,
													finderItemShutDown,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemShutDown"};

MenuItemTemplate finderItemCleanUpByNameID = 		{0,
													finderItemCleanUpByName,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemCleanUpByName"};

MenuItemTemplate finderItemColorBlackID = 			{0,
													finderItemColorBlack,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorBlack"};

MenuItemTemplate finderItemColorBlueID = 			{0,
													finderItemColorBlue,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorBlue"};

MenuItemTemplate finderItemColorYellowBrownID = 	{0,
													finderItemColorYellowBrown,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorYellowBrown"};

MenuItemTemplate finderItemColorGray1ID = 			{0,
													finderItemColorGray1,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorGray1"};

MenuItemTemplate finderItemColorRedID = 			{0,
													finderItemColorRed,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorRed"};

MenuItemTemplate finderItemColorPurpleID = 			{0,
													finderItemColorPurple,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorPurple"};

MenuItemTemplate finderItemColorOrangeID = 			{0,
													finderItemColorOrange,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorOrange"};

MenuItemTemplate finderItemColorPinkID = 			{0,
													finderItemColorPink,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorPink"};

MenuItemTemplate finderItemColorDarkGreenID = 		{0,
													finderItemColorDarkGreen,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorDarkGreen"};

MenuItemTemplate finderItemColorAquaID = 			{0,
													finderItemColorAqua,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorAqua"};

MenuItemTemplate finderItemColorBrightGreenID = 	{0,
													finderItemColorBrightGreen,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorBrightGreen"};

MenuItemTemplate finderItemColorPaleGreenID = 		{0,
													finderItemColorPaleGreen,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorPaleGreen"};

MenuItemTemplate finderItemColorPeriwinkleBlueID = 	{0,
													finderItemColorPeriwinkleBlue,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorPeriwinkleBlue"};

MenuItemTemplate finderItemColorYellowID = 			{0,
													finderItemColorYellow,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorYellow"};

MenuItemTemplate finderItemColorWhiteID = 			{0,
													finderItemColorWhite,
													0,
													0,
													0,
													0x0000,
													(Long)"\pfinderItemColorWhite"};

char tellFinderMItemSelectedTitleString[] = "\pMItemSelected";

MenuTemplate tellFinderMItemSelectedPopUpMenuTemplate =	{0,
														0x0090,
														0x0000,
														(Long)tellFinderMItemSelectedTitleString,
														{(Long)&finderItemAboutID,
														(Long)&finderItemHelpID,
														(Long)&finderItemNewFolderID,
														(Long)&finderItemOpenID,
														(Long)&finderItemPrintID,
														(Long)&finderItemCloseID,
														(Long)&finderItemCloseAllID,
														(Long)&finderItemDuplicateID,
														(Long)&finderItemPutAwayID,
														(Long)&finderItemValidateID,
														(Long)&finderItemUndoID,
														(Long)&finderItemCutID,
														(Long)&finderItemCopyID,
														(Long)&finderItemPasteID,
														(Long)&finderItemClearID,
														(Long)&finderItemSelectAllID,
														(Long)&finderItemShowClipboardID,
														(Long)&finderItemStackWindowsID,
														(Long)&finderItemByIconID,
														(Long)&finderItemBySmallIconID,
														(Long)&finderItemByNameID,
														(Long)&finderItemByDateID,
														(Long)&finderItemBySizeID,
														(Long)&finderItemByKindID,
														(Long)&finderItemFormatID,
														(Long)&finderItemEraseID,
														(Long)&finderItemVerifyID,
														(Long)&finderItemEjectID,
														(Long)&finderItemCleanUpID,
														(Long)&finderItemEmptyTrashID,
														(Long)&finderItemPreferencesID,
														(Long)&finderItemIconInfoID,
														(Long)&finderItemShutDownID,
														(Long)&finderItemCleanUpByNameID,
														(Long)&finderItemColorBlackID,
														(Long)&finderItemColorBlueID,
														(Long)&finderItemColorYellowBrownID,
														(Long)&finderItemColorGray1ID,
														(Long)&finderItemColorRedID,
														(Long)&finderItemColorPurpleID,
														(Long)&finderItemColorOrangeID,
														(Long)&finderItemColorPinkID,
														(Long)&finderItemColorDarkGreenID,
														(Long)&finderItemColorAquaID,
														(Long)&finderItemColorBrightGreenID,
														(Long)&finderItemColorPaleGreenID,
														(Long)&finderItemColorPeriwinkleBlueID,
														(Long)&finderItemColorYellowID,
														(Long)&finderItemColorWhiteID,
														0x00000000L}};

PopupTemplate	tellFinderMItemSelectedPopUp =	{9,
												0x00000900L,
												{90,10,0,0},
												popUpControl,
												0x0060,
												0x3080,
												0L,
												120,
												(Long)&tellFinderMItemSelectedPopUpMenuTemplate,
												finderItemAbout};

/************************************************************************************************/

/* Here's a control used in association with tellFinderMItemSelected request code */

char	HiliteBitCheckBoxTitle[] = 		"\pMItem Hilite Bit";

CheckBoxTemplate HiliteBitCheckBox =	{8,
										0x00000901L,
										{110,10,0,0},
										checkControl,
										0x0000,
										0x1000,
										0L,
										(Long)HiliteBitCheckBoxTitle,
										1};												

/************************************************************************************************/

/* Here's a control used in association with finderSaysMItemSelected request code */

char	HandleItFlagCheckBoxTitle[] = 	"\pAbortItFlag";

CheckBoxTemplate HandleItFlagCheckBox =	{8,
										0x00000902L,
										{110,170,0,0},
										checkControl,
										0x0000,
										0x1000,
										0L,
										(Long)HandleItFlagCheckBoxTitle,
										0};												

/************************************************************************************************/

/* Here's a control used in association with tellFinderSetSelectedIcons request code */

char	DeselectIconsCheckBoxTitle[] = 	"\pDeselect Icons";

CheckBoxTemplate DeselectIconsCheckBox =	{8,
											0x0000805AL,
											{110,300,0,0},
											checkControl,
											0x0000,
											0x1000,
											0L,
											(Long)DeselectIconsCheckBoxTitle,
											0};												

/************************************************************************************************/

/* Here's a control used in association with tellFinderGetSelectedIcons and tellFinderGetWindowIcons request code */

char	ExtendedIconsCheckBoxTitle[] = 	"\pExtended Icons";

CheckBoxTemplate ExtendedIconsCheckBox =	{8,
											0x00000903L,
											{130,300,0,0},
											checkControl,
											0x0000,
											0x1000,
											0L,
											(Long)ExtendedIconsCheckBoxTitle,
											0};												

/************************************************************************************************/

/* Here's all the controls used for the tellFinderColorSelection request code */

char	EnterColorTextString[] = 			"Icon Color (format is wx00yz00)";

StaticTextTemplate ColorValueStatText =		{8,
											0x00000500L,
											{130,30,140,290},
											statTextControl,
											0x0002,
											0x1000,
											0L,
											(Long)EnterColorTextString,
											31};

TextEditTemplate	ColorValueTextEdit = 	{17,
											0x00000501L,
											{145,30,158,110},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											8};

static char SetIconColorButtonString[] =	"\ptellFinderColorSelection";

SimpleButtonTemplate SetIconColorButton =	{7,
											0x0000800EL,
											{145,140,0,0},
											simpleButtonControl,
											0x0000,
											fCtlProcRefNotPtr|fCtlWantsEvents,
											0L,
											(Long)SetIconColorButtonString};

/************************************************************************************************/									

/* Here's a button control used in to bring up the help window */

static char helpButtonString[] =	"\pHelp";

SimpleButtonTemplate helpButton =	{9,
									0x0000300L,
									{145,380,0,0},
									simpleButtonControl,
									0x0000,
									fCtlProcRefNotPtr|fCtlWantsEvents,
									0L,
									(Long)helpButtonString,
									NIL,
									{'?','/',0x0100,0x3900}};

/************************************************************************************************/
/*/
/* This menu item template is used for the tellFinderAddToExtras menu which creates new menu items */

MenuItemTemplate tellFinderAddToExtrasMenuItem =	{0,								/* Word - version number for template; must be set to zero */
													0x00000500L,					/* Word - Menu item ID */
													0,								/* Byte - Primary keystroke equivalent character */
													0,								/* Byte - Alternate keystroke equivalent character */
													0,								/* Byte - Character code for checked items */
													0x0000,							/* Word - Menu item flags */
													(Long)"\pFinderXDA ID $xxxx"};	/* Long - Reference to menu item */

/************************************************************************************************/									

/* This control is used to display the pathnames from the stringListHandle returned from the */
/* tellFinderGetSelectedIcons and tellFinderGetWindowIcons request codes */

TextEditTemplate MyWindCtl = 	{9,
								0x00001000L,
								{0,0,157,560},
								editTextControl,
								0x0000,
								0x5400,
								0L,
								0x40000000L,
								{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
								(CtlRecHndl) 0xFFFFFFFF};


/************************************************************************************************/

/* Here's all the controls used with the tellFinderMatchFileToIcon request code */

static char MatchButtonString[] = "\pMatch It";

SimpleButtonTemplate MatchButton =			{7,
											0x00002000L,
											{147,450,0,0},
											simpleButtonControl,
											0x0000,
											fCtlProcRefNotPtr|fCtlWantsEvents,
											0L,
											(Long)MatchButtonString};

char	VotingBitsTextString[] = "(word) Voting Bits";

StaticTextTemplate VotingBitsStatText =		{9,
											0x00002001L,
											{2,100,15,440},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)VotingBitsTextString,
											18,
											0};

TextEditTemplate	VotingBitsTextEdit = 	{17,
											0x00002002L,
											{2,10,15,90},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											4};

char	MatchWhichTextString[] = "(word) Match Which";

StaticTextTemplate MatchWhichStatText =		{9,
											0x00002003L,
											{17,100,30,440},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)MatchWhichTextString,
											18,
											0};

TextEditTemplate	MatchWhichTextEdit = 	{17,
											0x00002004L,
											{17,10,30,90},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											4};

char	FileTypeTextString[] = "(word) File Type";

StaticTextTemplate FileTypeStatText =		{9,
											0x00002005L,
											{32,100,45,440},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)FileTypeTextString,
											16,
											0};

TextEditTemplate	FileTypeTextEdit = 		{17,
											0x00002006L,
											{32,10,45,90},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											4};

char	AuxTypeTextString[] = "(long) Aux Type";

StaticTextTemplate AuxTypeStatText =		{9,
											0x00002007L,
											{47,100,60,440},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)AuxTypeTextString,
											15,
											0};

TextEditTemplate	AuxTypeTextEdit = 		{17,
											0x00002008L,
											{47,10,60,90},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											8};

char	FilenameTextString[] = "Filename to match";

StaticTextTemplate FilenameStatText =		{9,
											0x00002009L,
											{62,410,90,580},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)FilenameTextString,
											17,
											0};

TextEditTemplate	FilenameTextEdit = 		{17,
											0x0000200AL,
											{62,10,85,400},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											255};

char	CreateDateTextString[] = "(8 bytes hex) Create date/time, GS/OS format";

StaticTextTemplate CreateDateStatText =		{9,
											0x0000200BL,
											{87,100,100,440},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)CreateDateTextString,
											44,
											0};

TextEditTemplate	CreateDateTextEdit = 	{17,
											0x0000200CL,
											{87,10,100,90},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											8};

char	ModDateTextString[] = "(8 bytes hex) Mod date/time, GS/OS format";

StaticTextTemplate ModDateStatText =		{9,
											0x0000200DL,
											{102,100,115,440},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)ModDateTextString,
											41,
											0};

TextEditTemplate	ModDateTextEdit = 		{17,
											0x0000200EL,
											{102,10,115,90},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											8};

char	AccessTextString[] = "(word) Local Access";

StaticTextTemplate AccessStatText =			{9,
											0x0000200FL,
											{117,100,130,440},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)AccessTextString,
											19,
											0};

TextEditTemplate	AccessTextEdit = 		{17,
											0x00002010L,
											{117,10,130,90},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											4};

char	FlagsTextString[] = "(word) Flags: 15 = extended file, all others reserved";

StaticTextTemplate FlagsStatText =			{9,
											0x00002011L,
											{132,100,145,540},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)FlagsTextString,
											53,
											0};

TextEditTemplate	FlagsTextEdit = 		{17,
											0x00002012L,
											{132,10,145,90},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											4};

char	EOFTextString[] = "(long) Combined (resource and data fork) EOF";

StaticTextTemplate EOFStatText =			{9,
											0x00002013L,
											{147,100,160,440},
											statTextControl,
											0x0003,
											0x1000,
											0L,
											(Long)EOFTextString,
											44,
											0};

TextEditTemplate	EOFTextEdit = 			{17,
											0x00002014L,
											{147,10,160,90},
											editTextControl,
											0x0000,
											0x7400,
											0L,
											0x49800000L,
											{0xFFFF,0xFFFF,0xFFFF,0xFFFF},
											0L,
											0x0000,
											0L,
											0,
											0L,
											0,
											0L,
											0L,
											8};

/************************************************************************************************/									
