#include "typesiigs.r"
#include "rDefs.h"



/* Can't pass TEInsert rTextForLETextBox2 due to bug in text edit */
/* so I use rText insead */
/*
resource rTextForLETextBox2 (1) { 
};
*/

resource rVersion (1) {
	{1,0,0,beta,1},
	verUS,
	"FinderXDA",
	"Copyright 1989-91, Apple Computer, Inc."
	};

resource rComment (1) {
"The FinderXDA is a Finder Extension which tests all the SendRequest codes "
"which can be passed to the Finder by a Finder Extension or can be passed by "
"the Finder to a Finder Extension. 'finderSays' codes are passed by the Finder "
"to the Finder Extension and 'tellFinder' codes are sent by the Finder "
"Extension to the Finder."
};


resource rControlTemplate (HelpEditTextControlID) {
	HelpEditTextControlID,					//	control ID
	{0,0,157,560},							//	rect
	editTextControl {{
		0b0000000000000000,					//	flags
		0b0111010000001111,					//	more flags
		0,									//	refCon
		0b01000100000100000000000000000000,	//	text flags
		{0xFFFF,0xFFFF,0xFFFF,0xFFFF},		//	indent rect
		0xFFFFFFFF,							//	vert scroll bar
		0x0000,								//	vert scroll amount
		0,									//	horiz scroll bar
		0,									//	horiz scroll amount
		0,									//	style ref
		0b0000000000010101,					//	text descriptor
		HelpTextControlID,					//	text ref
		0									//	text length
	}},
};

resource rText (2) {
"FinderXDA V1.0b1\n"
"Written by Bob Haven\n"
"Date 3/3/91\n\n"
"Thanks to:\n"
"John Selhorst for his programming help\n"
"Margarita Sang for her testing of this DA\n"
"Andy 'FinderMan' Nicholas and Dave 'Tangent' Lyons for their debugging sessions\n\n"

"This DA tests the Finder's Inter-Process Communication features. Anything that communicates "
"via AcceptRequest or SendRequest calls to the Finder is a Finder Extension. Finder Extensions "
"make AcceptRequest calls to receive finderSays requests codes from the Finder. Finder "
"Extensions make SendRequest calls to pass tellFinder request codes to the Finder.\n\n"

"This DA can send and receive all currently supported request codes by using the various menus "
"and buttons in main DA window (tiltled 'FinderXDA'). This DA can receive all finderSays request "
"codes by using the finderSays menu. All but two of the tellFinder request codes can be sent by "
"this DA by using the tellFinder menu. The other two tellFinder request codes are sent by using "
"the MItemSelected menu or the tellFinderColorSelection button. The remaining TextEdit and "
"checkbox controls are used in conjunction with the other controls. Details of their use is "
"provided below.\n\n"

"The 'finderSays' Menu\n\n"

"The 'finderSays' menu installs separate request procs for each of the finderSays requests "
"codes. When you select one of the menui tems in this menu an AcceptRequests call is made, "
"passing the Finder the address of a 'RequestProc', which is your procedure to handle one "
"or any selected finderSays requests codes that the finder directs to your RequestProc. "
"Normally an application would use only one RequestProc to handle all finderSays request "
"codes, but I've broken them up to be handled by separate RequestProcs to simplify testing. "
"The last menu item removes all the RequestProcs. The following is a list of the finderSays "
"menu items and a short description of what they do:\n\n"

"finderSaysHello - Installs a RequestProc to handle the finderSaysMItemSelected "
"request code. The finderSaysHello request code is sent by the Finder whenever the "
"the Finder launches.\n\n"

"finderSaysGoodbye - Installs a RequestProc to handle the finderSaysMItemSelected "
"request code. The finderSaysGoodbye request code is sent by the Finder whenever the "
"the Finder quits.\n\n"

"finderSaysSelectionChanged - Installs a RequestProc to handle the finderSaysMItemSelected "
"request code. The finderSaysSelectionChanged request code is sent whenever a Finder "
"selection may have changed (i.e. clicking on a finder window, desktop, or desktop icon).\n\n"

"finderSaysMItemSelected - Installs a RequestProc to handle the finderSaysMItemSelected "
"request code. This request code is sent by the Finder whenever a menu selection from the "
"System MenuBar. The AbortItFlag checkbox below is used to set the abortItFlag field of "
"the dataOut buffer returned to the Finder. If this box is checked then the Finder will "
"abort the selection of the menu item. The Finder will continue handling the menu item "
"if this box is unchecked. The dataIn buffer for each request is displayed in an alert "
"window.\n\n" 

"finderSaysBeforeOpen - Installs a RequestProc to handle the finderSaysBeforeOpen "
"request code. This request code is sent whenever the Finder tries to open a document. "
"One request code is sent for each document you try to open. The dataIn buffer for each "
"request is displayed in an alert window.\n\n" 

"finderSaysOpenFailed - Installs a RequestProc to handle the finderSaysOpenFailed "
"request code. This request code is sent whenever the Finder tries to open a document "
"and can't find and application that supports opening the document through the "
"application. One request code is sent for each document you try to open. The dataIn buffer "
"for each request is displayed in an alert window.\n\n"

"finderSaysBeforeCopy - Installs a RequestProc to handle the finderSaysBeforeCopy "
"request code. This request code is is sent whenever you try to copy a file. It doesn't "
"work for duplicating files.\n\n"

"finderSaysIdle - Installs a RequestProc to handle the finderSaysIdle request code. This "
"request code is is sent whenever the Finder is idle. A small Rect is alternately filled "
"and erased when this request code is sent.\n\n"

"finderSaysExtrasChosen - Installs a RequestProc to handle the finderSaysMItemSelected "
"request code. This request code is sent whenever a Extras Menu menu item is selected that "
"belongs to the FInderXDA.\n\n"

"finderSaysBeforeRename - Installs a RequestProc to handle the finderSaysBeforeRename "
"request code. This request code is is sent whenever you try to rename a file.\n\n"

"finderSaysKeyHit - Installs a RequestProc to handle the finderSaysKeyHit request code. "
"This request code is sent whenever a key is hit that the Finder doesn't handle. For "
"example, almost any non-command key when you're not renaming an icon. To type keypresses "
"to the Finder with FinderXDA open, bring a Finder window to the front (or, if GSBug is "
"installed, put Caps Lock down).\n\n"  

"Remove Request Procs - Removes all RequestProcs so that all finderSays request codes "
"will not be handled by this DA. Use this menu item in conjunction with the other "
"'finderSays' menu items to block undesired request codes coming from the Finder.\n\n"

"The 'tellFinder' Menu\n\n"

"The 'tellFinder' menu exercises all but one of the Finder SendRequest codes. When a "
"SendRequest code is sent to the Finder, the Finder usually returns an output buffer "
"(dataOut) which contains the result of the call and other info. If a buffer is returned, "
"the result fields are displayed in a alert window. The following lists the 'tellFinder' "
"menu items and a short desription of what they do:\n\n"

"tellFinderGetDebugInfo - Calls SendRequest with the tellFinderGetDebugInfo request code. "
"The dataOut buffer is dispalyed in an alert window.\n\n"

"askFinderAreYouThere - Calls SendRequest with the askFinderAreYouThere request code.\n\n"

"tellFinderOpenWindow - Calls SendRequest with the tellFinderOpenWindow request code. "
"Type a valid GS pathname into the text edit control in the FX window and then select "
"this menu item. If the pathname is correct the window will be opened. GS/OS errors "
"(like $45 - volume not found or $40 - bad pathname syntax) will be returned in the "
"output buffer. All pathnames should start with a colon except special windows (Trash, "
"Clip, and About).\n\n"

"tellFinderCloseWindow - Calls SendRequest with the tellFinderCloseWindow request code. "
"Type in a valid GS pathname of an open window and then select this menu item. If the "
"pathname is correct the window will be closed. If the pathname is incorrect an error "
"will be returned in the output buffer.\n\n"

"tellFinderGetSelectedIcons - Calls SendRequest with the tellFinderGetSelectedIcons "
"request code. Select one or several icons in a Finder window or on the desktop and "
"then select this menu item. After clearing the alert window another window will be "
"displayed containing the pathnames of the selected icons.\n\n"

"tellFinderGetSelectedIcons(Extended) - Calls SendRequest with the tellFinderGetSelectedIcons "
"request code with bit 31 of dataIn set. Does the same thing as tellFinderGetSelectedIcons, "
"only the returned stringListHandle is for extended icons.\n\n"

"tellFinderSetSelectedIcons - Calls SendRequest with the tellFinderSetSelectedIcons "
"request code. Select an icon or icons from a window or the desktop and then select "
"the tellFinderGetSeletectedIcons menu item. Deselect icons and then select the "
"tellFinderSetSelcetedIcons menu item. The stringListHandle from the tellFinderGetSelectedIcons "
"is passed as dataIn to tellFinderSetSelectedIcons. The 'Deselect Icons' checkbox, if selected, "
"causes any other selected icons to be deselected prior to selecting the icons in the "
"stringListHandle. The checkbox doesn't work due to a Finder 6.0 bug. See the Finder 6.0 "
"documentation.\n\n"

"tellFinderLaunchThis(Ap) - Calls SendRequest with the tellFinderLaunchThis request "
"code. Type in valid GS pathname to an application and select this menu item. The "
"Finder will quit and the application will be launched.\n\n"

"tellFinderLaunchThis(Doc) - Calls SendRequest with the tellFinderLaunchThis request "
"code. Type in a valid GS pathname to a document, whose application supports launching by "
"opening the document, and select this menu item. The Finder will quit and the "
"application will be launched. This request codes is currently not implemented by the "
"Finder.\n\n"

"tellFinderShutDown(Off) - Calls SendRequest with the tellFinderShutDown request code "
"with dataIn set to 0 - turn off power.\n\n"

"tellFinderShutDown(Restart) - Calls SendRequest with the tellFinderShutDown request code "
"with dataIn set to 1 - restart system.\n\n"

"tellFinderShutDown(Quit) - Calls SendRequest with the tellFinderShutDown request code "
"with dataIn set to 2 - quit Finder.\n\n"

"tellFinderMatchFileToIcon - Calls SendRequest with the tellFinderMatchFileToIcon request "
"code. This request code is not yet implemented in this NDA.\n\n"

"tellFinderAddBundle - Calls SendRequest with the tellFinderAddBundle request code. This "
"request code is not yet implemented in this NDA.\n\n"

"tellFinderAboutChange - Calls SendRequest with the tellFinderAboutChange request code. "
"Type a valid pathname into the Pathname Text Edit Control and select the tellFinderAboutChange "
"menu item. If the pathname is to an open window you should see the Finder update the window "
"after you clear the alert window.\n\n"

"tellFinderCheckDatabase - Calls SendRequest with the tellFinderCheckDatabase request code. "
"This request code is not yet implemented in this NDA.\n\n"

"tellFinderAddToExtras - Calls SendRequest with the tellFinderAddToExtras request code. "
"A new menu item will be installed into the Exras menu. This DA allows only 16 menu items to "
"be added.\n\n"

"askFinderIdleHowLong - Calls SendRequest with the askFinderIdleHowLong request code. "
"The number of ticks since the last Finder event is displayed in an alert window.\n\n" 

"tellFinderGetWindowIcons - Calls SendRequest with the tellFinderGetWindowIcons request "
"code. I've set the DA up to return the list of icon pathnames for the window directly "
"into another window.\n\n"

"tellFinderGetWindowIcons(Extended) - Calls SendRequest with the tellFinderGetWindowIcons "
"request code with bit 31 of dataIn set. Does the same thing as tellFinderGetWindowIcons, "
"only the returned stringListHandle contains extended icons. See Finder 6.0 documentation, "
"a Finder patch was required to make this feature work in this DA.\n\n"

"tellFinderGetWindowInfo - Calls SendRequest with the tellFinderGetWindowInfo request "
"code. Returns window info for the window directly beneath the DA window.\n\n"

"tellFinderRemoveFromExtras - Calls SendRequest with the tellFinderRemoveFromExtras "
"request code. Removes the last menu item added to the Extas menu. This DA will allow "
"you to remove only the menu items that you installed.\n\n"

"tellFinderSpecialPreferences - Calls SendRequest with the tellFinderSpecialPreferences "
"request code. Before it calls SendRequest it puts up a dialog asking how you want to "
"set up the dataIn buffer for the SendRequest call.\n\n"

"The tellFinderMItemSelected Menu\n\n"

"tellFinderMItemSelected - Calls SendRequest with the tellFinderMItemSelected request "
"code. This will cause of the specified menu item in the System MenuBar to be selected. "
"If the 'MItem Hilite Bit' CheckBox is checked, the the menu owning the menu item to be "
"selected will be hilited during the operation. If the checkbox is not selected the the "
"menu item will still be selected, but will not be hilited during the operation.\n\n"

"The 'tellFinderColorSelection' Button and 'Icon Color' TextEdit controls are used to send "
"the tellFinderColorSelection request code to the Finder. To do this, select one or more "
"icons on the desktop or within a folder, type in a color value into the 'Icon Color' "
"TextEdit field (using the proper format), and then select the tellFinderColorSelction "
"button. The selected icons should be redrawn in the color passed in the call."

};
