(*
	charsAvailable() -- Return the number of characters available for reading from the serial port.

	To compile and link this file using Macintosh Programmer's Workshop,

		pascal -w charsAvailable.p
		link -m ENTRYPOINT -o HyperCommands -rt XFCN=7030 -sn Main=charsAvailable 
			charsAvailable.p.o "{MPW}"Libraries:interface.o "{MPW}"Libraries:Libraries:HyperXLib.o

	 Copyright 1987,88,89 by Apple Computer, Inc.

	Initial coding 9/87 by Harry R. Chesley.
*)

{$R-}

{$S charsAvailable } 	{ Segment name must be the same as the command name. }

unit DummyUnit;

interface

uses MemTypes, QuickDraw, OSIntf, HyperXCmd;

procedure EntryPoint(paramPtr: XCmdPtr);
	
implementation

procedure charsAvailable(paramPtr: XCmdPtr); forward;

procedure EntryPoint(paramPtr: XCmdPtr);

	begin
		charsAvailable(paramPtr);
	end;

procedure charsAvailable(paramPtr: XCmdPtr);

	var l: longInt;
		s: Str255;

	procedure Fail(errMsg: Str255); { set theResult and quit }
		begin
			paramPtr^.returnValue := PasToZero(paramPtr,errMsg);
			exit(charsAvailable);
		end;

	{$I SPortUtil.inc}

	begin
		if paramPtr^.paramCount <> 0 then Fail('parameter count is not 0');

		SetUpSPortGlobals;
		EnsureOpenPort;

		{ Get and return the character count from the port. }
		if SerGetBuf(ThisSPort.portInDev,l) <> noErr then Fail('SerGetBuf failed');
		LongToStr(paramPtr,l,s);
		paramPtr^.returnValue := PasToZero(paramPtr,s);
	end;

end.
