rule(analyze_design(A,B),
 and(
  bagof(C,entity(C),D),
  totalmatch(D,D,B,E,A))).


rule(attribute(A,B,C),
 and(
  attribute_data(A,B,C,D),
  provable(A,D))).


rule(bestinfo(nil,cons(0.500000,cons(cons(cons(unknown,nil),nil),nil))),
 true).

rule(bestinfo(cons(A,B),C),
 and(
  bestinfo(B,D),
  moreinfo(A,D,C))).


rule(dca,
 and(
  analyze_design(A,B),
  and(
   write('matchindex = '),
   and(
    write(B),
    and(
     nl,
     print_reasons(A)))))).


rule(dca_dfim(A),
 and(
  analyze_design(B,A),
  print_dfim(B))).


rule(entity(component(A)),
 component(A)).

rule(entity(feature(A,B,C)),
 feature(A,B,C)).


rule(matchcoefaux(A,B,C,cons(cons(D,cons(E,nil)),nil)),
 and(
  c_data(D,F,G,H,I,E),
  and(
   univ(F,cons(J,cons(K,L))),
   and(
    or(
     and(
      =(A,F),
      =(M,A)),
     or(
      and(
       =(J,component_set),
       and(
        univ(A,cons(N,cons(O,P))),
        and(
         mymember(O,cons(K,L)),
         =(M,A)))),
      and(
       =(J,feature_set),
       and(
        mymember(A,cons(K,L)),
        and(
         cut,
         =(M,A)))))),
    and(
     provable(M,I),
     translate(G,C)))))).

rule(matchcoefaux(A,B,0.500000,cons(cons(unknown,nil),nil)),
 true).


rule(moreinfo(cons(A,cons(B,nil)),C,C),
 and(
  =(A,0.500000),
  cut)).

rule(moreinfo(A,cons(B,cons(C,nil)),A),
 and(
  =(B,0.500000),
  cut)).

rule(moreinfo(cons(A,cons(B,nil)),cons(C,cons(D,nil)),cons(A,cons(E,nil))),
 and(
  @=<(A,C),
  and(
   @<(A,0.500000),
   and(
    union(B,D,E),
    cut)))).

rule(moreinfo(cons(A,cons(B,nil)),cons(C,cons(D,nil)),cons(C,cons(E,nil))),
 and(
  @<(C,A),
  and(
   @<(C,0.500000),
   and(
    union(D,B,E),
    cut)))).

rule(moreinfo(cons(A,cons(B,nil)),cons(C,cons(D,nil)),cons(C,cons(E,nil))),
 and(
  @=<(A,C),
  and(
   @>(A,0.500000),
   and(
    union(D,B,E),
    cut)))).

rule(moreinfo(cons(A,cons(B,nil)),cons(C,cons(D,nil)),cons(A,cons(E,nil))),
 and(
  @<(C,A),
  and(
   @>(C,0.500000),
   union(B,D,E)))).


rule(mymember(A,cons(A,B)),
 true).

rule(mymember(A,cons(B,C)),
 mymember(A,C)).


rule(print_dfim(nil),
 true).

rule(print_dfim(cons(cons(unknown,nil),nil)),
 write(' no c_data matched')).

rule(print_dfim(cons(cons(A,cons(B,nil)),C)),
 and(
  c_data(A,D,E,F,G,H),
  and(
   write(A),
   and(
    write('   rating = '),
    and(
     write(E),
     and(
      write('    entity = '),
      and(
       write(B),
       and(
        nl,
        print_dfim(C))))))))).


rule(print_reasons(nil),
 and(
  write('That is it'),
  nl)).

rule(print_reasons(cons(cons(A,nil),B)),
 and(
  c_data(A,C,D,E,F,G),
  and(
   write('cbk_id = '),
   and(
    write(A),
    and(
     nl,
     and(
      write('   relevant entities = '),
      and(
       write(C),
       and(
        nl,
        and(
         write('   rating = '),
         and(
          write(D),
          and(
           nl,
           and(
            write('   reason = '),
            and(
             write(E),
             and(
              nl,
              and(
               nl,
               print_reasons(B)))))))))))))))).


rule(provable(A,always),
 and(
  true,
  cut)).

rule(provable(A,and(B,C)),
 and(
  provable(A,B),
  and(
   provable(A,C),
   cut))).

rule(provable(A,not(B)),
 and(
  cut,
  not(provable(A,B)))).

rule(provable(A,with_attribute(B,C)),
 and(
  attribute_data(B,C,D),
  and(
   cut,
   provable(A,D)))).

rule(provable(A,with_attribute(B,C,D)),
 and(
  attribute_data(B,C,D,E),
  and(
   cut,
   provable(B,E)))).

rule(provable(A,B),
 and(
  call(B),
  cut)).


rule(totalmatch(nil,A,9.999999e-5,0.500000,cons(unknown,nil)),
 true).

rule(totalmatch(cons(A,B),C,D,E,F),
 and(
  totalmatch(B,C,G,H,I),
  and(
   bagof(cons(J,cons(K,nil)),matchcoefaux(A,C,J,K),L),
   and(
    bestinfo(L,cons(M,cons(N,nil))),
    and(
     moreinfo(cons(H,cons(I,nil)),cons(M,cons(N,nil)),cons(E,cons(F,nil))),
     and(
      utility(A,O),
      and(
       is(P,mul(M,O)),
       is(D,add(P,G))))))))).


rule(translate(excellent,1.001000),
 true).

rule(translate(verygood,0.800000),
 true).

rule(translate(good,0.600000),
 true).

rule(translate(poor,0.400000),
 true).

rule(translate(bad,0.200000),
 true).

rule(translate(verybad,0.001000),
 true).


rule(union(nil,A,A),
 true).

rule(union(cons(A,B),C,D),
 and(
  mymember(A,C),
  union(B,C,D))).

rule(union(cons(A,B),C,cons(A,D)),
 union(B,C,D)).


