max_val_prop_asserted(uts, 12000.01, max).
max_val_prop_asserted(izod, 15.01, max).
max_val_prop_asserted(hdt, 400.01, max).
max_val_prop_asserted(spec_grav, 5.01, max).
max_val_prop_asserted(tms, 1000.01, max).


rule(attribute_set(cons(uts,cons(izod,cons(hdt,cons(spec_grav,cons(tms,nil)))))),
 true).


rule(candidate(A),
 and(
  polymer(B,A),
  and(
   ok_by_type(B),
   ok_by_cutoffs(A)))).


rule(conc(nil,A,A),
 true).

rule(conc(cons(A,B),C,cons(A,D)),
 conc(B,C,D)).


rule(cutoff_assert,
 and(
  findall(and(A,B),cutoff(A,B),C),
  assertz(
   rule(qual_list(C),
    true)))).


rule(doit4(A),
 and(
  findall(B,candidate(B),C),
  doit41(C,A))).


rule(doit41(nil,nil),
 true).

rule(doit41(cons(A,B),cons(and(A,C),D)),
 and(
  total_points(A,C),
  doit41(B,D))).


rule(doit5,
 and(
  doit4(A),
  plist(A))).


rule(doit6(A,B),
 and(
  doit4(C),
  and(
   quicksort(C,D),
   truncate_list(A,D,B)))).


rule(doit7(A),
 and(
  doit6(A,B),
  plist(B))).


rule(get_head_of_cons(nil,nil),
 true).

rule(get_head_of_cons(cons(and(A,B),C),cons(A,D)),
 get_head_of_cons(C,D)).


rule(get_tail_of_cons(nil,nil),
 true).

rule(get_tail_of_cons(cons(and(A,B),C),cons(B,D)),
 get_tail_of_cons(C,D)).


rule(gt(and(A,B),and(C,D)),
 and(
  is(E,add(B,1000.021)),
  and(
   is(F,add(D,1000.021)),
   @<(E,F)))).



rule(myappend(nil,A,A),
 true).

rule(myappend(cons(A,B),C,cons(A,D)),
 myappend(B,C,D)).


rule(mymember(A,cons(A,B)),
 true).

rule(mymember(A,cons(B,C)),
 mymember(A,C)).


rule(ok_by_cutoffs(A),
 and(
  qual_list(B),
  qualify_list(A,B))).


rule(ok_by_type(A),
 and(
  type_list(B),
  mymember(A,B))).


rule(plist(nil),
 true).

rule(plist(cons(A,B)),
 and(
  write(A),
  and(
   nl,
   plist(B)))).


rule(qualify(A,B,C),
 and(
  attribute(B,A,D),
  and(
   is(E,add(D,1000.021)),
   and(
    is(F,add(C,1000.021)),
    @>=(E,F))))).


rule(qualify_list(A,nil),
 true).

rule(qualify_list(A,cons(and(B,C),D)),
 and(
  qualify(A,B,C),
  qualify_list(A,D))).


rule(quicksort(nil,nil),
 true).

rule(quicksort(cons(A,B),C),
 and(
  split(A,B,D,E),
  and(
   quicksort(D,F),
   and(
    quicksort(E,G),
    conc(F,cons(A,G),C))))).


rule(rev(nil,A),
 true).

rule(rev(cons(A,B),C),
 and(
  rev(B,D),
  myappend(D,cons(A,nil),C))).


rule(split(A,nil,nil,nil),
 true).

rule(split(A,cons(B,C),cons(B,D),E),
 and(
  gt(A,B),
  and(
   cut,
   split(A,C,D,E)))).

rule(split(A,cons(B,C),D,cons(B,E)),
 split(A,C,D,E)).


rule(sub_points(A,B,C),
 and(
  attribute(B,A,D),
  and(
   max_val_prop_asserted(B,E,F),
   and(
    coeff(B,G),
    is(C,div(mul(D,G),E)))))).


rule(total_points(A,B),
 and(
  attribute_set(C),
  total_points_aux(A,C,B))).


rule(total_points_aux(A,nil,0.001000),
 true).

rule(total_points_aux(A,cons(B,C),D),
 and(
  total_points_aux(A,C,E),
  and(
   sub_points(A,B,F),
   is(D,add(E,F))))).


rule(truncate_list(A,nil,nil),
 true).

rule(truncate_list(0,A,nil),
 true).

rule(truncate_list(A,cons(B,C),cons(B,D)),
 and(
  is(E,sub(A,1)),
  truncate_list(E,C,D))).