;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Copyright 1987, 1988, 1989, 1990 by Ruben Kleiman for Apple Computer, Inc.
;;; Advanced Technology Group
;;;

(provide :sound-info)

(in-package 'sound)

(use-package '(ccl system))

;;; Sound information

;;; Synthetizer numbers
(defconstant noteSynth 1)
(defconstant waveTableSynth 3)
(defconstant sampledSynth 5)
(defconstant MIDISynthIn 7)
(defconstant MIDISynthOut 9)

;;; Errors
(defconstant badChannel -205)
(defconstant badFormat -206)
(defconstant noHardware -200)
(defconstant notEnoughHardware -201)
(defconstant queueFull -203)
(defconstant resProblem -204)

;;; Param2 values
(defconstant MidiInitChanFilter #x10)
(defconstant MidiInitRawMode #x100)

(defconstant StdQLength 128)


;;; Commands
(defconstant nullCmd 0)
(defconstant initCmd 1)
(defconstant freeCmd 2)
(defconstant quietCmd 3)
(defconstant flushCmd 4)
(defconstant waitCmd 10)
(defconstant pauseCmd 11) 
(defconstant resumeCmd 12)
(defconstant callBackCmd 13)
(defconstant syncCmd 14)
(defconstant emptyCmd 15)
(defconstant tickleCmd 20)
(defconstant requestNextCmd 21)
(defconstant howOftenCmd 22)
(defconstant wakeUpCmd 23)
(defconstant availableCmd 24)
(defconstant noteCmd 40)
(defconstant restCmd 41)
(defconstant freqCmd 42)
(defconstant ampCmd 43)
(defconstant timbreCmd 44)
(defconstant waveTableCmd 60)
(defconstant phaseCmd 61)
(defconstant soundCmd 80)
(defconstant bufferCmd 81)
(defconstant rateCmd 82)
(defconstant midiDataCmd 100)

(defrecord SndCommand
  (cmd :integer)
  (param1 :integer)
  (param2 :longint))

(defrecord SndChannel
  (nextChan :pointer)
  (firstMod :pointer)
  (callBack :pointer)
  (userInfo :longint)
  (wait :longint)
  (cmdInProg :SndCommand)
  (flags :integer)
  (qLength :integer)
  (qHead :integer)
  (qTail :integer)
  (queue :SndCommand))  ; actually, an array of 128 SndCommand's

(defrecord ModifierStub
  (nextStub :pointer)
  (code :pointer)
  (userInfo :longint)
  (count :longint)
  (every :longint)
  (flags :byte)
  (hState :byte))



