;;; DNET compilation and testing. Dan Suthers 24-Jun-90 23:56:11

(in-package :DNET)

(defun PATH-TO (file) 
  (concatenate 'string 
               #+:CCL "ccl;MODULES:DNET:"
               #+HP  "$tee/modules/dnet/"
               #+VAX "cai$disk:[suthers.lisp.modules.dnet]"
               #+:TI "suthers.modules;"
               #-(or :CCL HP VAX :TI) ""
               file))

(defun LISP-EXTENSION (file)
  (concatenate 'string 
               file
               #+HP ".l"
               #-HP ".lisp"))

(format T "~&Dribbling to ~A ..." (path-to "test.txt"))
(dribble (path-to "test.txt"))

(format T "~&Compiling ~A ..." (path-to (lisp-extension "DNET")))
(compile-file (path-to (lisp-extension "DNET")))

(format T "~&Loading ~A ..." (path-to "DNET"))
(load (path-to "DNET"))

(format T "~&Loading Tests in ~A ..." (path-to (lisp-extension "dnet-test")))
(load (path-to (lisp-extension "dnet-test")))

(format T "~&Loading ~A ..." (path-to (lisp-extension "dnet-analyze")))
(load (path-to (lisp-extension "dnet-analyze")))

(format T "~&Analyzing the TEST DNET:~%")
(dnet:analyze-dnet 'user::test)

(dribble)

;;; EOF