;;; HNET compilation and testing. Dan Suthers.

(in-package :HNET)

(defun PATH-TO (file) 
  (concatenate 'string 
               #+:CCL "ccl;MODULES:HNET:"
               #+HP  "$tee/modules/hnet/"
               #+VAX "cai$disk:[suthers.lisp.modules.hnet]"
               #+:TI "suthers.modules;"
               #-(or :CCL HP VAX :TI) ""
               file))

(defun LISP-EXTENSION (file)
  (concatenate 'string 
               file
               #+HP ".l"
               #-HP ".lisp"))

(format T "~&Dribbling to ~A ..." (path-to "test.txt"))
(dribble (path-to "test.txt"))

(format T "~&Compiling ~A ..." (path-to (lisp-extension "HNET")))
(compile-file (path-to (lisp-extension "HNET")))

(format T "~&Loading ~A ..." (path-to "HNET"))
(load (path-to "HNET"))

(format T "~&Loading Tests in ~A ..." (path-to (lisp-extension "hnet-test")))
(load (path-to (lisp-extension "hnet-test")))

(format T "~&Loading ~A ..." (path-to (lisp-extension "hnet-printer")))
(load (path-to (lisp-extension "hnet-printer")))

(format T "~&Printing TEST HNET:~%")
(hnet:print-hnet-below-root 'user::test t)

(dribble)

;;; EOF