/******************************************************************************\
* Header Files
\******************************************************************************/

#include <Dialogs.h>
#include <Errors.h>
#include <Fonts.h>
#include <Menus.h>
#include <Quickdraw.h>
#include <TextEdit.h>
#include <Windows.h>
#include "MenuTkl.h"
#include "ShowCursor.h"
#include "Startup.h"


/******************************************************************************\
* Static Function Declarations
\******************************************************************************/

void InitToolbox (void);
void InitGlobals (void);


#pragma segment %A5Init
/******************************************************************************\
* Startup - Perform startup operations
*
* Startup directs the initialization of Sharkey.
\******************************************************************************/

void
Startup ()
	{
	InitToolbox ();
	InitGlobals ();
	StartMenus ();
	}


#pragma segment %A5Init
/******************************************************************************\
* InitToolbox - Initialize the toolbox
*
* InitToolbox initializes the managers.
\******************************************************************************/

static void
InitToolbox ()
	{
	InitGraf (&qd.thePort);
	InitFonts ();
	InitWindows ();
	InitMenus ();
	TEInit ();
	InitDialogs ((ResumeProcPtr) null);
	}


#pragma segment %A5Init
/******************************************************************************\
* InitGlobals - Initialize global variables
*
* InitGlobals initializes the global variables in Sharkey.
\******************************************************************************/

static void
InitGlobals ()
	{
	gApplErr = noApplErr;
	gFlags = (short) 0;
	gLastWindow = (WindowPtr) null;
	SysEnvirons (2, &gEnvirons);
	return;
	}
